<%=
def wrap(s, width=78)
  #s.gsub(/(.{1,#{width}})(\s+|\Z)/, "\\1\n ")
  s.split("\n").map{ |x|
    if (x.length > width) then
      #x.gsub!(/(.{1,#{width}}) +(?=\S)/, "\\1\n ")
      x.gsub!(/(.{1,#{width}})( +|\Z)/, "\\1\n ")
    end
    x
  }.join("\n")+"\n"
end

def markup(l)
  l = l.gsub(/\[\[(.*?)\|(.*?)\]\]/, '\2')
  l = l.gsub(/\[\[(\*|-)?(.*?)\]\]/, '\2')
  return l
end

if not scope.lookupvar('deprecated::nodeinfo')['ldap']['architecture'].to_a.empty?
  arch = scope.lookupvar('deprecated::nodeinfo')['ldap']['architecture'][0]
else
  arch = 'unknown'
end

purp = ''
if scope.lookupvar('deprecated::nodeinfo').has_key?('nameinfo')
  purp += " " + wrap(scope.lookupvar('deprecated::nodeinfo')['nameinfo']) + "\n"
end

ninfo = scope.lookupvar('deprecated::nodeinfo')

extra = 'Welcome to ' + @fqdn
if not scope.lookupvar('deprecated::nodeinfo')['ldap']['purpose'].to_a.empty?
  p = scope.lookupvar('deprecated::nodeinfo')['ldap']['purpose'].clone()
  entries = ""

  if classes.include?("roles::buildd")
    entries += ", the Debian #{arch} build daemon"
    p.delete('buildd')
  end
  if classes.include?("roles::porterbox")
    entries += ", the Debian #{arch} porterbox"
    p.delete('porterbox')
  end

  if p.size() > 0
    entries += (entries == "") ? ", " : ".  Also "
    entries +="used for the following services:\n"
    scope.lookupvar('deprecated::nodeinfo')['ldap']['purpose'].sort.each do |l|
      l = markup(l)
      entries += "\t#{l}\n"
    end
  else
    entries += ".\n"
  end
  extra += entries
else
  extra += "."
end
purp += " " + wrap(extra) + "\n"

if not scope.lookupvar('deprecated::nodeinfo')['ldap']['physicalHost'].to_a.empty?
  if ninfo['ldap']['physicalHost'][0] =~ /ganeti/
    phys_host = 'cluster'
  else
    phys_host = 'physical host'
  end
  purp += wrap(" This virtual server runs on the #{phys_host} #{ninfo['ldap']['physicalHost'][0]}, " +
               "which is hosted at #{ninfo['hoster']['longname']}."
               )
elsif scope.lookupvar('deprecated::nodeinfo')['hoster']['name']
  purp += wrap(" This server is hosted at #{ninfo['hoster']['longname']}.")
end


vms = []
scope.lookupvar('deprecated::allnodeinfo').keys.sort.each do |node|
  if scope.lookupvar('deprecated::allnodeinfo')[node]['physicalHost'] and scope.lookupvar('deprecated::allnodeinfo')[node]['physicalHost'].include?(@fqdn)
    vms << node
  end
end
unless vms.empty?
  purp += "\nThe following virtual machines run on this system:\n"
  vms.each do |node|
    purp += "\t- #{node}"
    if scope.lookupvar('deprecated::allnodeinfo')[node]['purpose']
      purp += ":\n"
      scope.lookupvar('deprecated::allnodeinfo')[node]['purpose'].sort.each do |l|
        l = markup(l)
        purp += "\t    " + l + "\n"
      end
    else
      purp += "\n"
    end
  end
end


if scope.lookupvar('::cluster')
  purp += "\n This server is a node in ganeti cluster: "
  purp += scope.lookupvar('::cluster').to_s + ":\n"
  purp += "\t" + scope.lookupvar('::cluster_nodes').split.sort.map{ |x| x.split('.')[0] }.join(", ") + ".\n"

  purp += ""
  purp += "\tCurrently the master node is $(cat /var/lib/ganeti/ssconf_master_node).\n"
  #nodes = scope.lookupvar('::cluster_nodes').sort
  #nodes.each do |node|
  #  purp += "\t" + node + "\n"
  #end
  #nodes.reject{|node| node.eql?(fqdn)}.each do |node|
  #  purp += "\t" + node + "\n"
  #  scope.lookupvar('deprecated::allnodeinfo')[node]['ipHostNumber'].each do |ip|
  #    purp += "\t\t" + ip + "\n"
  #  end
  #end
end


if classes.include?('bacula::not_a_client') then
  purp += "\n " + wrap("Note that this host is _NOT_ being backed up.  If you care about your data, run your own backups.")
end

if scope.lookupvar('deprecated::nodeinfo').has_key?('footer')
  purp += "\n" + wrap(scope.lookupvar('deprecated::nodeinfo')['footer'])
end

purp

# vim:set et:
# vim:set sts=2 ts=2:
# vim:set shiftwidth=2:
-%>
